> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.schoolset.io/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.schoolset.io/_mcp/server.

# Advance students to the next academic year

POST https://ssuccessv2.com/app/api/v2/school/structure/advance/{from_year}/{to_year}
Content-Type: application/json

Migrates selected grade or class students from one academic year into another with optional status mappings.

Reference: https://docs.schoolset.io/api-reference/school-set-api/school-structure/advance-students-to-next-academic-year

## Authentication

- `Authorization` header (bearer token, required) — The signed-in SchoolSet user token sent by the frontend.

## Request

### Path parameters

- `from_year` (integer, required)
- `to_year` (integer, required)

### Body (application/json)

This endpoint expects an object.

- `data` (list of ApiV2SchoolStructureAdvanceFromYearToYearPostRequestBodyContentApplicationJsonSchemaDataItems, required)
- `to_student_status_id` (integer, optional, nullable)
- `from_year_student_status_id` (integer, optional, nullable)

## Response

### 200

Student advancement completed successfully.

- `status` (string, optional)
- `message` (string, optional)
- `data` (list of any, optional)

## Errors

### 400 Bad Request Error

The migration mapping could not be prepared.

- `status` (string, required)
- `message` (string, required)
- `data` (any, optional, nullable)

### 401 Unauthorized Error

Authentication is required.

- `status` (string, required)
- `message` (string, required)
- `data` (any, optional, nullable)

### 403 Forbidden Error

The user cannot edit school settings.

- `status` (string, required)
- `message` (string, required)
- `data` (any, optional, nullable)

### 404 Not Found Error

A source or destination academic year was not found.

- `status` (string, required)
- `message` (string, required)
- `data` (any, optional, nullable)

### 422 Unprocessable Entity Error

Migration data failed validation.

- `message` (string, required)
- `errors` (map from string to list of string, required)

## Types

### ApiV2SchoolStructureAdvanceFromYearToYearPostRequestBodyContentApplicationJsonSchemaDataItems

- `id` (integer, required)
- `type` (enum, required)
  - Allowed values: `grade`, `class`
- `migrates_from_id` (integer, optional, nullable)
- `migrates_from_model` (enum, optional, nullable)
  - Allowed values: `grade`, `class`
- `student_ids` (list of integer, optional)

## Examples

**Request**

```json
{
  "data": [
    {
      "id": 8,
      "type": "grade"
    }
  ]
}
```

**Response**

```json
{
  "status": "success",
  "message": "Migrated successfully",
  "data": []
}
```

**SDK Code**

```python
import requests

url = "https://ssuccessv2.com/app/api/v2/school/structure/advance/2025/2026"

payload = { "data": [
        {
            "id": 8,
            "type": "grade"
        }
    ] }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://ssuccessv2.com/app/api/v2/school/structure/advance/2025/2026';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"data":[{"id":8,"type":"grade"}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://ssuccessv2.com/app/api/v2/school/structure/advance/2025/2026"

	payload := strings.NewReader("{\n  \"data\": [\n    {\n      \"id\": 8,\n      \"type\": \"grade\"\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://ssuccessv2.com/app/api/v2/school/structure/advance/2025/2026")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"data\": [\n    {\n      \"id\": 8,\n      \"type\": \"grade\"\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://ssuccessv2.com/app/api/v2/school/structure/advance/2025/2026")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"data\": [\n    {\n      \"id\": 8,\n      \"type\": \"grade\"\n    }\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://ssuccessv2.com/app/api/v2/school/structure/advance/2025/2026', [
  'body' => '{
  "data": [
    {
      "id": 8,
      "type": "grade"
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://ssuccessv2.com/app/api/v2/school/structure/advance/2025/2026");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"data\": [\n    {\n      \"id\": 8,\n      \"type\": \"grade\"\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["data": [
    [
      "id": 8,
      "type": "grade"
    ]
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://ssuccessv2.com/app/api/v2/school/structure/advance/2025/2026")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```